<?
# This file is distributed under GNU GPLv1 and further versions.
# This file was written by Zdenek Styblik
# This file is part of weathermap4rrd-ng
#
# original file: currentvalues.php
# 
# Zdenek Styblik
# e-mail: zdenek <dot> styblik <at> gmail <dot> com
#
# Last update: 2008-07-07
#
if (isset($_GET['config'])) {
	$cfgfile = urldecode($_GET['config']);
} else {
	$cfgfile = NULL;
	exit();
}
if (isset($_GET["link"])) {
	$linkname = urldecode($_GET["link"]);
} else {
	echo "Incorrect call to currentvalues.php. Link variable is not defined";
	exit();
}
require_once 'lib/configfile.php';
$configfile = new config_file($cfgfile);
if ($configfile->readConfig() !== false) {
	$config = $configfile->getConfig();
	if (isset($config->links) && is_object($config->links)) {
		if (isset($config->links->{$linkname})) {
			$link = $config->links->{$linkname};
			if (!isset($link->target)) {
				echo "Link target file is missing.";
				exit();
			}
			if (!isset($link->targetin))
				$link->targetin = $link->target;
			if (!isset($link->targetout))
				$link->targetout = $link->target;
			if (!isset($link->inpos))
				$link->inpos = 1;
			if (!isset($link->unit))
				$link->unit = "bytes";
			if (!isset($link->outpos))
				$link->outpos = 2;
			$rrdstep = $configfile->getRRDStep();
			require_once 'lib/rrd.php';
			$rrd = new rrdtools();
			require_once 'lib/graphic.php';
			$graphic = new graphic();
			if (($in = $rrd->rrdtool_get_last_value($link->targetin, $link->inpos, $rrdstep)) == false)
				exit("Error in RRD #1;");
			$indisplay = $graphic->toDisplay($in);
			if (($out = $rrd->rrdtool_get_last_value($link->targetout, $link->outpos, $rrdstep)) == false)
				exit("Error in RRD #2;");
			$outdisplay = $graphic->toDisplay($out);
			echo "<html>\n\t<head>\n\t</head>\n\t<body>\n";
			echo "\t\tInput : {$indisplay}";
			echo "\n\t\t<br />\n\t\t";
			echo "Output : {$outdisplay}";
			echo "\n\t</body>\n</html>";
		} else {
			echo "Link '{$linkname}' doesn't exist.";
			exit();
		}
	} else {
		echo "No links were defined.";
		exit();
	}
} else {
	exit("Config file not found. Make sure weathermap4rrd has access to it.");
}
?>
